import os
import sys

from shutil import copytree
from filecmp import dircmp
from difflib import unified_diff

from typing import List
from tempfile import TemporaryDirectory
from contextlib import contextmanager

from tests import TEST_DATA_DIR, EComTestCase
from scripts.ecomUpdate import main as ecom_update


class TestCodeGeneration(EComTestCase):
    """ Test the codegen functionality. """

    def testGeneratesExample(self):
        """ Test that the codegen generates code for the example database correctly. """
        with TemporaryDirectory() as tempDir:
            self.assertEqual(0, self._runEcomUpdate(
                '--database', TEST_DATA_DIR, os.path.join(tempDir, 'src'), os.path.join(tempDir, 'inc')),
                'Expected the "ecomUpdate" script to generate the code for the '
                'example communication database without an error')
            self._assertDirectoryAreSame(os.path.join(os.path.dirname(__file__), 'data', 'codegen', 'example'), tempDir)
        with TemporaryDirectory() as tempDir:
            self.assertEqual(0, self._runEcomUpdate(
                '--forBase', '--database', TEST_DATA_DIR, os.path.join(tempDir, 'src'), os.path.join(tempDir, 'inc')),
                'Expected the "ecomUpdate" script to generate the code for the '
                'example communication database as the base without an error')
            self._assertDirectoryAreSame(
                os.path.join(os.path.dirname(__file__), 'data', 'codegen', 'example_base'), tempDir)

    def testContainsAutogenNotice(self):
        """ Test that each autogenerated file contains an auto-generation notice. """
        templatePath = os.path.abspath(os.path.join(os.path.dirname(__file__), '..', 'scripts', 'templates'))
        for file in os.listdir(templatePath):
            path = os.path.join(templatePath, file)
            if os.path.isfile(path):
                with open(path, encoding='utf-8') as templateFile:
                    self.assertIn('%AUTO_GENERATED_NOTICE%', templateFile.read(),
                                  f'Expected {path} to contain an auto-generation notice')

    def _assertDirectoryAreSame(self, expectedDirectory: str, directory: str):
        """
        Verify that both directories contain the exact same files in the exact same folder structure.

        :param expectedDirectory: The directory containing the expected file and folder structure.
        :param directory: The directory that is verified against the expected directory.
        """
        if not os.path.exists(expectedDirectory):
            copytree(directory, expectedDirectory)
            return
        reports = [('', dircmp(expectedDirectory, directory))]
        message = []
        while reports:
            dirPath, directoryComparison = reports.pop(0)
            reports.extend((os.path.join(dirPath, name), subdir)
                           for name, subdir in directoryComparison.subdirs.items())
            for path in directoryComparison.left_only:
                message.append(f'Missing file {dirPath}{os.path.sep}{path}')
            for path in directoryComparison.right_only:
                message.append(f'Unexpected file {dirPath}{os.path.sep}{path}')
            for path in directoryComparison.diff_files:
                with open(os.path.join(expectedDirectory, dirPath, path)) as expectedFile, \
                        open(os.path.join(directory, dirPath, path)) as actualFileFile:
                    message.append(''.join(unified_diff(actualFileFile.readlines(), expectedFile.readlines(),
                                                        fromfile=os.path.join('actual', dirPath, path),
                                                        tofile=os.path.join('expected', dirPath, path))))
        if message:
            self.fail('Directory does not match expected:\n' + '\n'.join(message))

    @contextmanager
    def _programArguments(self, arguments: List[str]):
        """
        A context manager that replaces `sys.argv` while it is active.

        :param arguments: The new contents of `sys.argv`.
        """
        previousArguments = sys.argv[:]
        sys.argv = arguments
        yield
        sys.argv = previousArguments

    def _runEcomUpdate(self, *arguments: str) -> int:
        """
        Run the ecomUpdate script with the given arguments.

        :param arguments: The arguments to the ecomUpdate script.
        :return: The return code of the script.
        """
        with self._programArguments(['ecomUpdate.py', *arguments]):
            result = ecom_update()
            return 0 if result is None else result
